/////////////////////////////// ME_SUPERLIFT 1.4 (16th June 2005) ////////////////////////////////
// WHAT DOES THIS PLUGIN DO?                                                                    //
//   SuperLift is an enhancement of Lerk Lift and SuperLerk and though allows players           //
//   to pick up each other and fly around.                                                      //
//   Lerks can pick up:                                                                         //
//     - Skulks,Gorges                                                                          //
//     - Onos  if the Lerk has Adrenaline                                                       //
//     - Marines (JP makes them immune)                                                         //
//     - HAs if the Lerk has Adrenaline                                                         //
//   JPer can pick up:                                                                          //
//     - Gorges                                                                                 //
//     - HAs if the JPer has Catalyst                                                           //
//                                                                                              //
// COMMANDS                                                                                     //
//   - amx_superlift on/off   Requires ADMIN_BAN to turn of SuperLift completly.                //
//   - say /lifton            Allow teammates to pick you up.                                   //
//   - say /liftoff           Refuse to be picked up by teammates. However this doesn't affect  //
//                            enemies.                                                          //
//   - say /lifthelp          Shows you SuperLift's help ingame                                 //
//                                                                                              //
// MADE BY                                                                                      //
//   Author         : mE  -  Code based on Cheesy Peteza's AMX Lerk Lift                        //
//   WWW            : www.psix.info                                                             //
//   Mail           : mE@psix.info                                                              //
//   Other projects : ns_psix, ns_looping, PsiX.info CMS, Unchain the Chambers,                 //
//                    (Equipment) Store, Gorge Recycle Plugin, Marine Meal, aso..               //
//                                                                                              //
// THANKS TO                                                                                    //
//   o modns.org for such a great NS modding community forum                                    //
//   o Cheesy Peteza, because the plugin is based on his Lerk Lift and actually it's also his   //
//     unstuck-code                                                                             //
//   o Steve_Dudenhoeffer, CheesyPeteza (again) and everybody else who helped me or by whom's   //
//     code I got "inspired" ;)                                                                 //
//                                                                                              //
// HISTORY                                                                                      //
//   o 23.08.04 - 1.0   - Initial release                                                       //
//   o 24.08.04 - 1.1   - Lerk now requires Adrenaline to pick up Onos                          //
//                      - Holding down USE-Button now makes you immune to friendly lifters      //
//                      - Dropping selected weapon when being lifted by a Lerk                  //
//   o 01.09.04 - 1.2   - Added check so that lifted can only be set free if they will not be   //
//                        stucked through anything (checking visible contact)                   //
//                      - Altered players-position when being lifted                            //
//                      - Fixed redeem-prevention                                               //
//   o 19.10.04 - 1.3   - Made compatible with newest NS2AMX                                    //
//                      - Made compatible with MvM                                              //
//                                                                                              //
// Port to Amx Mod X by White Panther                                                           //
//   o xx.xx.05 - 1.3.2c - MvM and AvA support                                                  //
//                       - changed in MvM to pick up marines and HA instead of jetpackers       //
//   o 18.03.05 - 1.3.2d - update for NS 3 final                                                //
//   o 16.06.05 - 1.4    - code improvements to custom damage code                              //
//                       - minor code tweaks                                                    //
//                       - moved from pev/set_pev to entity_get/entity_set (no fakemeta)        //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////
//                  DON'T EDIT BELOW UNLESS YOU KNOW WHAT YOU'RE DOING                          //
//////////////////////////////////////////////////////////////////////////////////////////////////

#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <ns>

#define ADMIN_ACCESS    ADMIN_BAN
#define HUD_CHANNEL1    3
#define HUD_CHANNEL2    4

#define	SOLID_NOT	0		// no interaction with other objects
#define	SOLID_SLIDEBOX	3		// touch on edge, but not an onground
#define FL_DUCKING	(1<<14)		// Player flag -- Player is fully crouched
#define START_DISTANCE	32		// The first search distance for finding a free location in the map
#define MAX_ATTEMPTS	128		// How many times to search in an area for a free space
#define CP_LLNOLIFT	1		// Bitmask stored in user key "cp". I use the same key for all my plugins,
					// so don't just go making up new masks if you edit this plugin!
					// I didn't edit that one because it's basically exactly what I needed

new activemode = 0
new g_MaxPlayers
new bool:g_sldisabled
new g_lifting[33], g_lifted[33]
new Float:g_LastUseTime[33], Float:g_LastDamage[33],g_NumDamages[33]
new Float:g_LastEnergyCheck[33], Float:g_LastEnergy[33]

enum {
	PLAYERCLASS_NONE = 0,
	PLAYERCLASS_ALIVE_MARINE,
	PLAYERCLASS_ALIVE_ALIEN,
	PLAYERCLASS_ALIVE_JETPACK,
	PLAYERCLASS_ALIVE_HEAVY_MARINE,
	PLAYERCLASS_ALIVE_LEVEL1,
	PLAYERCLASS_ALIVE_LEVEL2,
	PLAYERCLASS_ALIVE_LEVEL3,
	PLAYERCLASS_ALIVE_LEVEL4,
	PLAYERCLASS_ALIVE_LEVEL5,
	PLAYERCLASS_ALIVE_DIGESTING,
	PLAYERCLASS_ALIVE_GESTATING,
	PLAYERCLASS_DEAD_MARINE,
	PLAYERCLASS_DEAD_ALIEN,
	PLAYERCLASS_COMMANDER,
	PLAYERCLASS_REINFORCING,
	PLAYERCLASS_SPECTATOR
}

enum {
	PLAYMODE_UNDEFINED = 0,
	PLAYMODE_READYROOM,
	PLAYMODE_PLAYING,
	PLAYMODE_AWAITINGREINFORCEMENT,	// Player is dead and waiting in line to get back in
	PLAYMODE_REINFORCING,		// Player is in the process of coming back into the game
	PLAYMODE_OBSERVER
}

public plugin_init() {
	register_plugin("SuperLift", "1.4", "mE @ psix.info & Cheesy Peteza & White Panther")
	register_cvar("me_superlift", "1.4", FCVAR_SERVER)
	
	register_cvar("superlift_enabled", "1")
	
	register_clcmd("say /liftoff", "disableSL", 0, "Saying this will stop players from picking you up")
	register_clcmd("say_team /liftoff", "disableSL", 0, "Saying this will stop players from picking you up")
	register_clcmd("say /lifton", "enableSL", 0, "Saying this will stop players from picking you up")
	register_clcmd("say_team /lifton", "enableSL", 0, "Saying this will stop players from picking you up")
	register_clcmd("say /lifthelp","show_rules",0,"Saying this will show you SuperLift's help")
	register_clcmd("say_team /lifthelp","show_rules",0,"Saying this will show you SuperLift's help")
	
	register_concmd("amx_superlift", "switchOnOff", ADMIN_ACCESS, "<on|off> Enable or disable SuperLift")
	
	g_MaxPlayers = get_maxplayers()
	
	if ( ns_get_build("team_command",1,0) >= 2 && ns_get_build("team_hive",1,0) == 0 )
		activemode = 1
	else if ( ns_get_build("team_command",1,0) == 0 && ns_get_build("team_hive",1,0) >= 2 )
		activemode = 2
	
	register_event("CurWeapon","switchweapon","be","1=1")
	
	if ( !get_cvar_num("superlift_enabled") )
		g_sldisabled = true
}

public plugin_modules(){
	require_module("engine")
	require_module("ns")
}

public switchweapon(id){
	if ( activemode == 2 || ( activemode == 0 && entity_get_int(id,EV_INT_team) != 1 ) )
		return PLUGIN_CONTINUE
	
	if ( !is_user_connected(g_lifted[id]) )
		return PLUGIN_CONTINUE
	
	if ( entity_get_int(id,EV_INT_team) == entity_get_int(g_lifted[id],EV_INT_team) )
		return PLUGIN_CONTINUE
	
	engclient_cmd(id,"weapon_knife")		// switch weapon to knife if marine is being lifted
	
	return PLUGIN_CONTINUE
}

public show_rules(id){
	new message1[256] = "SuperLift -- Help^n^nSuperLift is a plugin that allows players to pick up each other.^nLerks can pick up:^n-Skulks,Gorges^n-Onos if they have Adrenaline^n-Marines (JP makes them immune)^n-HAs if they have Adrenaline"
	new message2[256] = "JPers can pick up:^n-Marines^n-Gorges^n-HAs if they have Catalyst^n^nPicking up enemy players deals damage to them.^n^nsay /lifton or /liftoff to allow/deny friendly players picking you up"
	//format(message,255,")
	
	set_hudmessage(255,255,255, 0.6, 0.3, 2, 0.02,10.0, 0.01, 0.1, HUD_CHANNEL1)
	show_hudmessage(id,message1)
	set_hudmessage(255,255,255, 0.6, 0.5, 2, 0.02,10.0, 0.01, 0.1, HUD_CHANNEL2)
	show_hudmessage(id,message2)
}

public server_frame(){
	if ( g_sldisabled )
		return PLUGIN_CONTINUE
	
	new class
	
	for ( new id; id <= g_MaxPlayers; id++ ){
		if ( !is_user_connected(id) )
			continue
		
		class = ns_get_class(id)
		
		if ( class == CLASS_LERK || class == CLASS_JETPACK ){
			if ( is_user_connected(g_lifted[id]) )				// this happens if a lifted player evolves to a lerk
				freeLifted(id,0)					// free him
		
			if ( entity_get_int(id,EV_INT_button) & IN_USE ){
				if ( (get_gametime() - g_LastUseTime[id]) < 1.0 )
					continue						// Only react to one use button press a second to pick up players
				g_LastUseTime[id] = get_gametime()
			
				if ( g_lifting[id] ){
					new res = freeLifted(g_lifting[id],1)
					if ( res == 0 )
						client_print(id,print_center,"Couldn't set free lifted player")
					continue
				}else{
					new entid, part
					get_user_aiming(id, entid, part)
					
					// check if lerk/jp has adreneline/catalyst
					new adren_cat = ( class == CLASS_LERK ? ns_get_mask(id,MASK_ADRENALINE) : ns_get_mask(id,MASK_PRIMALSCREAM) )
					
					if ( is_user_connected(entid) ) {
						if ( entity_range(id, entid) < 200 ) {
							new class_ent = ns_get_class(entid)
							if ( entity_get_int(entid,EV_INT_team) == entity_get_int(id,EV_INT_team) ){
								if ( ( class == CLASS_JETPACK && ( class_ent == CLASS_MARINE || ( class_ent == CLASS_HEAVY && adren_cat ) ) ) ||							// jetpackers can pick up "normal" marines or HAs if they have catalyst
									( class == CLASS_LERK && ( class_ent == CLASS_GORGE || class_ent == CLASS_SKULK || ( class_ent == CLASS_ONOS && adren_cat ) || class_ent == CLASS_GESTATE ) ) ){	// lerks can pick up gorges,skulks,onos and gestating players
									
									if ( entity_get_int(entid,EV_INT_button) & IN_USE ){
										client_print(id,print_center,"Can't pick up friendly player if he USE something")
										continue
									}
									
									new CPstring[32]
									get_user_info(entid, "cp", CPstring, 31)
									new CPvalue = str_to_num(CPstring)
									
									if ( CPvalue & CP_LLNOLIFT ){
										client_print(id, print_center, "The Player has disabled lifting")
										continue
									}
								}else{
									client_print(id,print_center,"Can't pick up that class")
									continue
								}
							}else{
								// lerk or jp can pick up marines, gorges and with adreneline/catalyst HAs
								if ( class_ent == CLASS_MARINE || class_ent == CLASS_GORGE || ( adren_cat && class_ent == CLASS_HEAVY ) )
									client_print(id,print_center, "Picked up enemy player")
								// lerk can pick up skulks, gorges, gestates and with adreneline onoses
								else if ( class == CLASS_LERK && ( class_ent == CLASS_SKULK || class_ent == CLASS_GESTATE || ( class_ent == CLASS_ONOS && adren_cat ) ) )	// Lerk can pick up enemy skulk, gorge, gestate, marine and with adreneline HA + onos
									client_print(id,print_center, "Picked up enemy player")
								else{
									client_print(id,print_center,"Can't pick up that enemy player")
									continue
								}
							}
							g_NumDamages[entid] = 0
							g_lifting[id] = entid
							g_lifted[entid] = id				// Pick up the Player
							entity_set_int(entid,EV_INT_solid, SOLID_NOT)		// and "mark" him as lifted
							notifyStatus(entid, id, 1)
							
							client_print(entid,print_chat,"[AMX] Say /lifthelp to see SuperLift's help")
							
							if ( ( activemode == 1 || ( activemode == 0 && entity_get_int(entid,EV_INT_team) == 1 ) ) && entity_get_int(entid,EV_INT_team) != entity_get_int(id,EV_INT_team) )
								engclient_cmd(entid,"drop;wait;weapon_knife")
						}
					}
				}
			}
		}else if ( is_user_connected(g_lifted[id]) ) {					// A player being carried
			if ( entity_get_int(id,EV_INT_team) != entity_get_int(g_lifted[id],EV_INT_team) ){			// If the carried player is not on the same team of the lifter
				if ( get_gametime() - g_LastDamage[id] >= 1.0 ){		// Take 10 Damage/second
					new Float:damage = 0.2 * g_NumDamages[id] * g_NumDamages[id]
					if ( damage < 10.0 )
						damage = 10.0
					
					new dummy
					take_dmg(id,get_user_weapon(g_lifted[id],dummy,dummy),g_lifted[id],damage,"Lifting")
					
					
					g_NumDamages[id]++
					g_LastDamage[id] = get_gametime()
				}
			}else{
				if ( entity_get_int(id,EV_INT_button) & IN_USE ){				// If the carried player is on the same team of the lifter and presses use, free it
					if ( ( get_gametime() - g_LastUseTime[id] ) < 1.0 )
						continue
					g_LastUseTime[id] = get_gametime()
					
					new res = freeLifted(id,1)
					if ( res == 1 )
						continue
				}
			}
			new class_lifted = ns_get_class(g_lifted[id])
			if ( !( class == CLASS_GORGE || class == CLASS_SKULK || ( class == CLASS_ONOS && ns_get_mask(g_lifted[id],MASK_ADRENALINE) ) || class == CLASS_GESTATE ||
				class == CLASS_MARINE || ( class == CLASS_HEAVY && ( ns_get_mask(g_lifted[id],MASK_PRIMALSCREAM) || ns_get_mask(g_lifted[id],MASK_ADRENALINE) ) ) ) ){
				
				freeLifted(id,0)
				continue
			}
			if ( ( class_lifted != CLASS_LERK && class_lifted != CLASS_JETPACK ) || !is_user_alive(id) || !is_user_alive(g_lifted[id]) ){
				freeLifted(id,0)							        // if lifter or lifted is dead free it.
				continue
			}
			
			// Manually increase energy for player if its not going up itself
			if ( entity_get_int(id,EV_INT_team) == 2 && ( get_gametime() - g_LastEnergyCheck[id] ) >= 0.1 ){
				g_LastEnergyCheck[id] = get_gametime()		// Increase the energy of a
										// Player manually if it is
				new Float:energy = entity_get_float(id, EV_FL_fuser3)			// stuck in the ground.
				if ( (energy == g_LastEnergy[id]) && (energy != 1000.0) ) {
					energy += 7.8
					if ( energy > 1000.0 )
						energy = 1000.0
					entity_set_float(id,EV_FL_fuser3, energy)
				}
				g_LastEnergy[id] = energy
			}
			
			// The origin must be set every server frame, otherwise the Lifted will have a laggy view.
			if ( entity_range(id,g_lifted[id]) > 200.0 ){		// if the distance is above 200 in one single frame, drop lifted
				freeLifted(id,0)				// this will hopefully prevent redeeming
				continue
			}
			
			new Float:temporig[3]
			entity_get_vector(g_lifted[id], EV_VEC_origin, temporig)
			temporig[2] -= ( entity_get_int(g_lifted[id],EV_INT_team) == 2 ) ? 16.0 : 32.0	// only 16/32 units lower
			entity_set_vector(id,EV_VEC_origin, temporig)				// Update the players position
			entity_set_vector(id, EV_VEC_velocity, Float:{0.0,0.0,0.0})			// Disables fall damage
		}
	}
	return PLUGIN_CONTINUE
}

public switchOnOff(id, level, cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	
	new arg1[32]
	read_argv(1, arg1, 31)
	
	if ( equal(arg1, "off") ){
		client_print(id, print_console, "[AMXX] Lifting disabled.")
		set_cvar_num("superlift_enabled", 0)
		g_sldisabled = true
		
		for ( new i = 1; i <= g_MaxPlayers; i++ )
			if ( g_lifted[i] )
				freeLifted(i,0)
	}else if ( equal(arg1, "on") ){
		client_print(id, print_console, "[AMXX] Lifting enabled.")
		set_cvar_num("superlift_enabled", 1)
		g_sldisabled = false
	}else{
		client_print(id, print_console, "[AMXX] Invalid option, valid options are 'off' or 'on'")
	}
	return PLUGIN_CONTINUE
}

public client_disconnect(id){
	if ( g_lifting[id] ){		// Disconnected player was a Lerk carrying a Lifted
		freeLifted(g_lifting[id],0)
	}else if ( g_lifted[id] ){	// Disconnected player was a Lifted being carried by a Lerk
		freeLifted(id,0)
	}
}

public client_putinserver(id) 
	set_task(20.0, "showUsage", id)

public showUsage(id) {
	if ( g_sldisabled || !( 1 <= entity_get_int(id,EV_INT_team) <= 2 ) )
		return PLUGIN_HANDLED
	
	client_print(id, print_chat, "[AMXX] SuperLift is enabled on this server. To disable Players from picking you up say /liftoff ( /lifton to enable )")
	client_print(id, print_chat, "[AMXX] Say /lifthelp to see SuperLift's help")
	
	return PLUGIN_HANDLED
}

public disableSL(id) {
	new CPstring[32]
	get_user_info(id, "cp", CPstring, 31)
	new CPvalue = str_to_num(CPstring)

	if ( CPvalue & CP_LLNOLIFT ){
		client_print(id, print_chat, "[AMXX] Lifting is already disabled")
	}else{
		CPvalue |= CP_LLNOLIFT
		num_to_str(CPvalue, CPstring, 31)
		set_user_info(id, "cp", CPstring)
		client_print(id, print_chat, "[AMXX] You can no longer be picked up")
	}

	return PLUGIN_CONTINUE
}

public enableSL(id) {
	new CPstring[32]
	get_user_info(id, "cp", CPstring, 31)
	new CPvalue = str_to_num(CPstring)

	if ( CPvalue & CP_LLNOLIFT ){
		CPvalue = CP_LLNOLIFT
		num_to_str(CPvalue, CPstring, 31)
		set_user_info(id, "cp", CPstring)
		client_print(id, print_chat, "[AMXX] You can now be picked up")
	} else {
		client_print(id, print_chat, "[AMXX] Lifting is already enabled")
	}

	return PLUGIN_CONTINUE
}

public freeLifted(id,reqline) {
	if ( is_user_connected(id) && is_user_alive(id) ){
		if ( reqline == 1 ){					// if required visible contact ( to avoid stucking through walls)
			new check
			new Float:origin[3]
			new Float:ret[3]
			entity_get_vector(id,EV_VEC_origin,origin)
			new res
			for( new i = 0; i < 5; i++ ){				// try to create visible contact 5 times
				res = moveToFreeLocation(id)
				
				if ( res == 1 ){
					new Float:new_origin[3]
					entity_get_vector(id,EV_VEC_origin,new_origin)
					
					res = trace_line(g_lifted[id],origin,new_origin,ret)
					
					if ( res == 0 || res == -1 || is_user_connected(res) ){
						check = 1
						break
					}else{
						entity_set_vector(id,EV_VEC_origin,origin)
					}
				}else{
					entity_set_vector(id,EV_VEC_origin,origin)
					break
				}
			}
			if ( check != 1 ){
				client_print(id,print_center,"You could NOT be set free (debug: ent %i)",res)
				return 0
			}
		}else{
			moveToFreeLocation(id)
		}
		entity_set_int(id,EV_INT_solid, SOLID_SLIDEBOX)
	}
	notifyStatus(id, g_lifted[id], 2)
	
	g_lifting[g_lifted[id]] = 0
	g_lifted[id] = 0
	
	return 1
}

// Status:
// 1: Pickup Lifted
// 2: Release Lifted
public notifyStatus(liftedid, lerkid, status){
	if ( is_user_connected(liftedid) ){
		if ( is_user_alive(liftedid) ){
			if ( is_user_connected(lerkid) ){
				new lerkname[32]
				get_user_name(lerkid,lerkname, 31)
				switch(status) {
					case 1: client_print(liftedid, print_center, "You have been lifted by %s", lerkname)
					case 2: client_print(liftedid, print_center, "You have detached from %s", lerkname)
				}
			}else
				client_print(liftedid, print_center, "You have detached")
		}
	}
	if ( is_user_connected(lerkid) ){
		if ( is_user_alive(lerkid) ){
			if ( is_user_connected(liftedid) ){
				new liftedname[32]
				get_user_name(liftedid, liftedname, 31)
				switch(status){
					case 1: client_print(lerkid, print_center, "Picked up %s", liftedname)
					case 2: client_print(lerkid, print_center, "%s has been released", liftedname)
				}
			}else
				client_print(lerkid, print_center, "The Player has been released")
		}
	}
}

public moveToFreeLocation(id){
	new Float:origin[3], Float:new_origin[3], hullsize, distance
	
	hullsize = getHullSize(id)
	if ( !hullsize )
		hullsize = HULL_LARGE
	
	entity_get_vector(id,EV_VEC_origin, origin)
	origin[2] += 32.0
	distance = START_DISTANCE
	
	while( distance < 1000 ){	// 1000 is just incase of bugs, should never get anywhere near that
		for ( new i = 0; i < MAX_ATTEMPTS; i++ ){
			new_origin[0] = random_float(origin[0]-distance,origin[0]+distance)
			new_origin[1] = random_float(origin[1]-distance,origin[1]+distance)
			new_origin[2] = random_float(origin[2]-distance,origin[2]+distance)
			
			if ( trace_hull(new_origin, hullsize, id) == 0 ){
				//set_origin(id, new_origin)
				entity_set_vector(id,EV_VEC_origin, new_origin)
				//client_print(id, print_chat, "[DEBUG] Took %i attempts (Dist:%i)", i, distance)
				return 1
			}
		}
		distance += START_DISTANCE
	}
	return 0
}

public getHullSize(id){
	new class = ns_get_class(id)
	
	if ( class == 1 || class == 2 || class == 3 )
		return HULL_HEAD
	
	if ( class >= 4 && class <= 8 )
		return (entity_get_int(id,EV_INT_flags) & FL_DUCKING) ? HULL_HEAD : HULL_HUMAN
	
	if ( class == 5 )
		return (entity_get_int(id,EV_INT_flags) & FL_DUCKING) ? HULL_HUMAN : HULL_LARGE
	
	return HULL_LARGE
}

take_dmg(victim,iflictor,attacker,Float:dmg_to_do,weapon_name[] = ""){
	if ( is_user_alive(victim) ){
		new Float:NS_DMG_AP_AMPLIFIER = 1.14
		new players_dies
		new Float:vic_hp = entity_get_float(victim, EV_FL_health)
		new Float:vic_ap = entity_get_float(victim, EV_FL_armorvalue)
		
		if ( vic_ap >= 1.0 ){
			new Float:dmg_parts = dmg_to_do / 3
			new Float:dmg_to_ap = ( dmg_parts * NS_DMG_AP_AMPLIFIER )
			if ( vic_ap - dmg_to_ap < 1.0 ){
				vic_hp -= float(floatround( (dmg_parts + dmg_to_ap - vic_ap ) * NS_DMG_AP_AMPLIFIER ))
				vic_ap = 0.0
			}else{
				vic_hp -= dmg_parts
				vic_ap -= float(floatround( dmg_parts * NS_DMG_AP_AMPLIFIER ))
			}
		}else
			vic_hp -= dmg_to_do
		
		if ( vic_hp < 1.0 )
			players_dies = 1
		
		entity_set_int(victim, EV_ENT_dmg_inflictor, iflictor)
		entity_set_float(victim, EV_FL_armorvalue, vic_ap)
		if ( players_dies ){
			entity_set_float(victim, EV_FL_health, 1.0)
			set_msg_block(get_user_msgid("DeathMsg"),BLOCK_ONCE)
			fakedamage(victim,"trigger_hurt",2.0,1)
		}else
			entity_set_float(victim, EV_FL_health, vic_hp)
		
		if ( players_dies ){
			if ( is_user_connected(attacker) ){
				new frags = get_user_frags(attacker) + 1
				set_user_frags(attacker,frags)
				
				new score = ns_get_score(attacker) + frags
				if ( ns_is_combat() )
					score += get_level(attacker)
				
				new deaths = ns_get_deaths(attacker)
				
				new class = scoreboard_class(attacker)
				
				new team = entity_get_int(attacker,EV_INT_team)
				
				message_begin(MSG_ALL, get_user_msgid("ScoreInfo"))
				write_byte(attacker)
				write_short(score)	// score
				write_short(frags)	// frags
				write_short(deaths)	// deaths
				write_byte(class)	// class
				write_short(0)		// auth status
				write_short(team)	// team
				message_end()
			}else
				attacker = victim
			
			message_begin( MSG_ALL, get_user_msgid("DeathMsg"),{0,0,0},0)
			write_byte(attacker)
			write_byte(victim)
			if ( !strlen(weapon_name) ){
				entity_get_string(iflictor,EV_SZ_classname,weapon_name,54)
				if ( containi(weapon_name,"weapon_") != -1 )
					replace(weapon_name,54,"weapon_","")
			}
			write_string(weapon_name)
			message_end()
			
			if ( ns_is_combat() )
				ns_set_exp(attacker,ns_get_exp(attacker) + float( get_level(victim) * 10 + 50 ) )
		}
	}
}

get_level(id){
	new cur_xp = floatround(ns_get_exp(id))
	new temp_xp, xp_to_next_lvl = 100, player_level = 1
	while ( cur_xp > ( temp_xp + xp_to_next_lvl ) ){
		temp_xp += xp_to_next_lvl
		xp_to_next_lvl += 50
		player_level++
	}
	
	return player_level
}

stock scoreboard_class(id){
	new class_score
	new cur_class = ns_get_class(id)
	new alive = is_user_alive(id)
	new playerclass = entity_get_int(id,EV_INT_playerclass)
	new teamname[32]
	get_user_team(id,teamname,31)
			
	if ( playerclass == PLAYMODE_AWAITINGREINFORCEMENT || playerclass == PLAYMODE_REINFORCING ){
		class_score = PLAYERCLASS_REINFORCING
	}else if ( containi(teamname,"alien") != -1 ){
		if ( !alive )
			class_score = PLAYERCLASS_DEAD_ALIEN
		else if ( cur_class == CLASS_SKULK )
			class_score = PLAYERCLASS_ALIVE_LEVEL1
		else if ( cur_class == CLASS_GORGE )
			class_score = PLAYERCLASS_ALIVE_LEVEL2
		else if ( cur_class == CLASS_LERK )
			class_score = PLAYERCLASS_ALIVE_LEVEL3
		else if ( cur_class == CLASS_FADE )
			class_score = PLAYERCLASS_ALIVE_LEVEL4
		else if ( cur_class == CLASS_ONOS )
			class_score = PLAYERCLASS_ALIVE_LEVEL5
		else if ( cur_class == CLASS_GESTATE )
			class_score = PLAYERCLASS_ALIVE_GESTATING
		else
			class_score = PLAYERCLASS_ALIVE_ALIEN
	}else if ( containi(teamname,"marine") != -1 ){
		if ( !alive )
			class_score = PLAYERCLASS_DEAD_MARINE
		else if ( ns_get_mask(id,MASK_DIGESTING) )
			class_score = PLAYERCLASS_ALIVE_DIGESTING
		else if ( cur_class == CLASS_COMMANDER )
			class_score = PLAYERCLASS_COMMANDER
		else if ( cur_class == CLASS_HEAVY )
			class_score = PLAYERCLASS_ALIVE_HEAVY_MARINE
		else if ( cur_class == CLASS_JETPACK )
			class_score = PLAYERCLASS_ALIVE_JETPACK
		else
			class_score = PLAYERCLASS_ALIVE_MARINE
	}else if ( containi(teamname,"specta") != -1 )
		class_score = PLAYERCLASS_SPECTATOR
	
	return class_score
}